<?php
/**
 * @category   Alogic
 * @package    Alogic_Productregistration
 * @author     dushyantjoshia@gmail.com
 * @copyright  This file was generated by using Module Creator(http://code.vky.co.in/magento-2-module-creator/) provided by VKY <viky.031290@gmail.com>
 * @license    http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
 */

namespace Alogic\Productregistration\Controller\Index;

use Alogic\Productregistration\Model\ProductregistrationFactory;
use Magento\Framework\App\Action\Context;
use Magento\Framework\Filesystem;
use Magento\Framework\Image\AdapterFactory;
use Magento\Framework\Stdlib\DateTime\TimezoneInterface;
use Magento\MediaStorage\Model\File\UploaderFactory;

class Save extends \Magento\Framework\App\Action\Action {
	/**
	 * @var Productregistration
	 */
	protected $_productregistration;
	protected $uploaderFactory;
	protected $adapterFactory;
	protected $timezone;
	protected $filesystem;

	public function __construct(
		Context $context,
		ProductregistrationFactory $productregistration,
		UploaderFactory $uploaderFactory,
		AdapterFactory $adapterFactory,
		TimezoneInterface $timezone,
		Filesystem $filesystem
	) {
		$this->_productregistration = $productregistration;
		$this->uploaderFactory = $uploaderFactory;
		$this->adapterFactory = $adapterFactory;
		$this->filesystem = $filesystem;
		$this->timezone = $timezone;
		parent::__construct($context);
	}
	public function execute() {
		$data = $this->getRequest()->getParams();
		$singleData = [];

		$productregistration = $this->_productregistration->create();
		$objectManager = \Magento\Framework\App\ObjectManager::getInstance();
		$imageFile = $objectManager->create('Alogic\Productregistration\Helper\Data')->uploadFile('file', $productregistration);
		if (!$imageFile->getFile()) {
			throw new \Magento\Framework\Exception\LocalizedException(__('The wrong file is specified.'));
		}
		$singleData['file'] = $imageFile->getFile();
		$singleData['confirm'] = isset($data['confirm']) ? 1 : 0;
		$singleData['name'] = $data['firstname'] . ' ' . $data['lastname'];
		$singleData['firstname'] = $data['firstname'];
		$singleData['lastname'] = $data['lastname'];
		$singleData['email'] = $data['email'];
		$singleData['form_key'] = $data['form_key'];
		$dateTimeZone = $this->timezone->date(new \DateTime($data['date_purchase']))->format('Y/m/d H:i:s');
		$singleData['date_purchase'] = $dateTimeZone;
		$singleData['invoice_no'] = $data['invoice_no'];
		//$result_data = array_filter($data['product_name']);
		//for ($i = 1; $i < count($data['product']) + 1; $i++) {
		$nData = [];
		foreach ($data['product'] as $pkey => $product) {
			foreach ($product as $key => $value) {
				if ($key == 'product_name') {
					if ($value == '') {
						unset($data['product'][$pkey]);

					}

				}

			}

		}

		foreach ($data['product'] as $product) {

			$j = 0;
			foreach ($product as $key => $value) {

				if ($key == 'product_name') {
					if ($value == '') {
						continue;
					}

				}
				if ($key == 'serialnumber') {
					foreach ($value as $val) {
						if ($j == 0) {
							$serKey = 'serialnumber';
						} else {
							$serKey = 'serialnumber' . ($j + 1);
						}
						if (isset($val[$j])) {
							$singleData[$serKey] = $val;
						}

						$j++;
					}
				} else {

					$singleData[$key] = $value;
				}

			}

			$productregistration->setData($singleData);

			if ($productregistration->save()) {
				$this->messageManager->addSuccessMessage(__('You saved the data.'));
			} else {
				$this->messageManager->addErrorMessage(__('Data was not saved.'));
			}
		}

		//}

		$resultRedirect = $this->resultRedirectFactory->create();
		$resultRedirect->setPath('productregistration');
		return $resultRedirect;
	}
}
